'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.firstBelow = exports.allBelow = exports.firstChilds = exports.allChilds = exports.first = exports.getFirst = exports.all = exports.get = undefined;

var _pytils = require('pytils');

var _pure = require('./pure');

var _get = function _get(what, value) {
  var process = void 0;
  switch (what) {
    case 'first':
      return _pure._getFirst;

    case 'text':
    case 'class':
      process = (0, _pure.getAttr)(what);
      break;

    case 'list':
      process = (0, _pure.getList)(value);
      break;

    case 'dangerouns-html':
      process = _pure.getHtml;
      break;

    case 'html':
      process = (0, _pytils.composeDown)(_pure.getHtml, _pure.clearHtml);
      break;

    case 'attr':
    default:
      process = (0, _pure.getAttr)(value);
  }
  return (0, _pure.mapListWith)(process);
};

var get = exports.get = function get(what, value) {
  return (0, _pytils.composeDown)(_get(what, value), _pure.removeEmpty, _pure.flatten, _pure.deduplicate);
};

var _with = function _with(what, key, value) {
  var process = void 0;
  switch (what) {
    case 'tag':
      return (0, _pure.hasTag)(key);

    case 'attr':
      return value ? (0, _pure.hasAttrEq)(key, value) : (0, _pure.hasAttr)(key);

    case 'class':
      return key ? (0, _pure.hasClassEq)(key) : (0, _pure.hasAttr)('class');

    case 'text':
      return (0, _pure.hasAttr)('text');

    default:
      return _pure.emptyList;
  }
};

var _all = function _all(what, key, value) {
  return (0, _pure.filterListWith)(_with(what, key, value));
};

var all = exports.all = function all(what, key, value) {
  return (0, _pytils.composeDown)(_all(what, key, value), _pure.removeEmpty, _pure.deduplicate);
};

var getFirst = exports.getFirst = get('first');

var getChilds = (0, _pytils.composeDown)(get('list', 'childs'), _pure.flatten, _pure.removeEmpty);

var first = exports.first = function first(what, key, value) {
  return (0, _pytils.composeDown)(all(what, key, value), getFirst);
};

var allChilds = exports.allChilds = function allChilds(what, key, value) {
  return (0, _pytils.composeDown)(getChilds, all(what, key, value));
};

var firstChilds = exports.firstChilds = function firstChilds(what, key, value) {
  return (0, _pytils.composeDown)(allChilds(what, key, value), getFirst);
};

var recursiveBelow = function recursiveBelow(splitter, list) {
  var split = splitter(list);
  return split.not.length <= 0 ? split.with : split.with.concat(recursiveBelow(splitter, getChilds(split.not)));
};

var _allBelow = function _allBelow(what, key, value) {
  var splitter = (0, _pure.splitListWith)(_with(what, key, value));
  return function (list) {
    return recursiveBelow(splitter, list);
  };
};

var allBelow = exports.allBelow = function allBelow(what, key, value) {
  return (0, _pytils.composeDown)(_allBelow(what, key, value), _pure.removeEmpty, _pure.deduplicate);
};

var firstBelow = exports.firstBelow = function firstBelow(what, key, value) {
  return (0, _pytils.composeDown)(allBelow(what, key, value), getFirst);
};